$('#gamePanes').css({bottom: 9, minHeight: 'initial', height: 'auto'});
function resizePanes() {
  // enlarge both panes to fit their contents
  $('.elementListWrapper').css({maxHeight: 'initial'});

  // Work out how much we need to shrink the panes by.
  var spaceNeeded = $('#gamePanesRunning').outerHeight(true) - $('#gamePanes').height();
  if (spaceNeeded > 0) {

    // First see if the inventory pane can be shrunk
    if ($('#lstInventory li').length > 5) {
      // Work out how large (in pixels) the inventory can be to limit it to 5 items
      var targetSize = $('#lstInventory li').first().outerHeight(true) * 5;

      // If the window is really small, we don't want to limit the inventory to 5 items and the placesObjects to 2
      // So in this case, make them both half of the available space
      targetSize = Math.min(targetSize, ($('#inventoryWrapper').outerHeight(true) + $('#placesObjectsWrapper').outerHeight(true) - spaceNeeded)/2 - 1);

      // reduce the spaceNeeded by the amount of space we're saving shrinking the inventory
      spaceNeeded += targetSize - $('#inventoryWrapper').height();
      // and if reducing the inventory to 5 items would leave a space at the bottom of the sidebar, reduce it by less
      if (spaceNeeded < -1) {
        targetSize -= spaceNeeded;
      }
      // And finally, shrink the inventory list
      $('#inventoryWrapper').css({maxHeight: targetSize});
    }

    // Do we still need to save space?
    if (spaceNeeded > 0) {
      // This time it's simple: Just shrink the placesObjects list by exactly enough to fit it on the screen
      $('#placesObjectsWrapper').css({maxHeight: $('#placesObjectsWrapper').height() - spaceNeeded -1});
    }
  }
}
$(function() {

  // Make a copy of the default functions
  // Your game probably doesn't need all of these, but they're included so this code can be used
  //   without modification in other games
  var originalUpdateList = updateList;
  var originalUpdateVerbButtons = updateVerbButtons;
  var originalUpdateStatus = updateStatus;
  var originalSetCustomStatus = setCustomStatus;
  var originalUpdateStatusVisibility = updateStatusVisibility;
  var originalShowStatusVisible = showStatusVisible;

  // Then we replace each of those functions with one that calls the original version,
  //   and then calls resizePanes()
  updateList = function(name, data) {
    originalUpdateList(name, data);
    resizePanes();
  };
  updateVerbButtons = function(item, arr, prefix) {
    originalUpdateVerbButtons(item, arr, prefix);
    resizePanes();
  };
  updateStatus = function(txt) {
    originalUpdateStatus(txt);
    resizePanes();
  };
  setCustomStatus = function(txt) {
    originalSetCustomStatus(txt);
    resizePanes();
  };
  updateStatusVisibility = function() {
    originalUpdateStatusVisibility();
    resizePanes();
  };
  showStatusVisible = function(t) {
    originalShowStatusVisible(t);
    resizePanes();
  };

  // And we might also need to adjust the scroll bars when the window is resized
  $(window).resize( resizePanes );
});
